diff --git a/contrib/postgres_fdw/sql/postgres_fdw.sql b/contrib/postgres_fdw/sql/postgres_fdw.sql
index 9a8f9e28135..d826701c5a2 100644
--- a/contrib/postgres_fdw/sql/postgres_fdw.sql
+++ b/contrib/postgres_fdw/sql/postgres_fdw.sql
@@ -2497,6 +3562,20 @@ select foo.f1, loct1.f1 from foo join loct1 on (foo.f1 = loct1.f1) order by foo.
 explain (verbose, costs off)
 	select foo.f1, loct1.f1 from foo left join loct1 on (foo.f1 = loct1.f1) order by foo.f2 offset 10 limit 10;
 select foo.f1, loct1.f1 from foo left join loct1 on (foo.f1 = loct1.f1) order by foo.f2 offset 10 limit 10;
+
+-- Test with non-cursor mode
+SET postgres_fdw.use_cursor = false;
+-- inner join; expressions in the clauses appear in the equivalence class list
+explain (verbose, costs off)
+	select foo.f1, loct1.f1 from foo join loct1 on (foo.f1 = loct1.f1) order by foo.f2 offset 10 limit 10;
+select foo.f1, loct1.f1 from foo join loct1 on (foo.f1 = loct1.f1) order by foo.f2 offset 10 limit 10;
+-- outer join; expressions in the clauses do not appear in equivalence class
+-- list but no output change as compared to the previous query
+explain (verbose, costs off)
+	select foo.f1, loct1.f1 from foo left join loct1 on (foo.f1 = loct1.f1) order by foo.f2 offset 10 limit 10;
+select foo.f1, loct1.f1 from foo left join loct1 on (foo.f1 = loct1.f1) order by foo.f2 offset 10 limit 10;
+SET postgres_fdw.use_cursor = true;
+
 RESET enable_hashjoin;
 RESET enable_nestloop;
 
@@ -3275,31 +4354,73 @@ EXPLAIN (COSTS OFF)
 SELECT t1.a,t2.b,t3.c FROM fprt1 t1 INNER JOIN fprt2 t2 ON (t1.a = t2.b) INNER JOIN fprt1 t3 ON (t2.b = t3.a) WHERE t1.a % 25 =0 ORDER BY 1,2,3;
 SELECT t1.a,t2.b,t3.c FROM fprt1 t1 INNER JOIN fprt2 t2 ON (t1.a = t2.b) INNER JOIN fprt1 t3 ON (t2.b = t3.a) WHERE t1.a % 25 =0 ORDER BY 1,2,3;
 
+-- Test with non-cursor mode
+SET postgres_fdw.use_cursor = false;
+EXPLAIN (COSTS OFF)
+SELECT t1.a,t2.b,t3.c FROM fprt1 t1 INNER JOIN fprt2 t2 ON (t1.a = t2.b) INNER JOIN fprt1 t3 ON (t2.b = t3.a) WHERE t1.a % 25 =0 ORDER BY 1,2,3;
+SELECT t1.a,t2.b,t3.c FROM fprt1 t1 INNER JOIN fprt2 t2 ON (t1.a = t2.b) INNER JOIN fprt1 t3 ON (t2.b = t3.a) WHERE t1.a % 25 =0 ORDER BY 1,2,3;
+SET postgres_fdw.use_cursor = true;
+
 -- left outer join + nullable clause
 EXPLAIN (VERBOSE, COSTS OFF)
 SELECT t1.a,t2.b,t2.c FROM fprt1 t1 LEFT JOIN (SELECT * FROM fprt2 WHERE a < 10) t2 ON (t1.a = t2.b and t1.b = t2.a) WHERE t1.a < 10 ORDER BY 1,2,3;
 SELECT t1.a,t2.b,t2.c FROM fprt1 t1 LEFT JOIN (SELECT * FROM fprt2 WHERE a < 10) t2 ON (t1.a = t2.b and t1.b = t2.a) WHERE t1.a < 10 ORDER BY 1,2,3;
 
+-- Test with non-cursor mode
+SET postgres_fdw.use_cursor = false;
+EXPLAIN (VERBOSE, COSTS OFF)
+SELECT t1.a,t2.b,t2.c FROM fprt1 t1 LEFT JOIN (SELECT * FROM fprt2 WHERE a < 10) t2 ON (t1.a = t2.b and t1.b = t2.a) WHERE t1.a < 10 ORDER BY 1,2,3;
+SELECT t1.a,t2.b,t2.c FROM fprt1 t1 LEFT JOIN (SELECT * FROM fprt2 WHERE a < 10) t2 ON (t1.a = t2.b and t1.b = t2.a) WHERE t1.a < 10 ORDER BY 1,2,3;
+SET postgres_fdw.use_cursor = true;
+
 -- with whole-row reference; partitionwise join does not apply
 EXPLAIN (COSTS OFF)
 SELECT t1.wr, t2.wr FROM (SELECT t1 wr, a FROM fprt1 t1 WHERE t1.a % 25 = 0) t1 FULL JOIN (SELECT t2 wr, b FROM fprt2 t2 WHERE t2.b % 25 = 0) t2 ON (t1.a = t2.b) ORDER BY 1,2;
 SELECT t1.wr, t2.wr FROM (SELECT t1 wr, a FROM fprt1 t1 WHERE t1.a % 25 = 0) t1 FULL JOIN (SELECT t2 wr, b FROM fprt2 t2 WHERE t2.b % 25 = 0) t2 ON (t1.a = t2.b) ORDER BY 1,2;
 
+-- Test with non-cursor mode
+SET postgres_fdw.use_cursor = false;
+EXPLAIN (COSTS OFF)
+SELECT t1.wr, t2.wr FROM (SELECT t1 wr, a FROM fprt1 t1 WHERE t1.a % 25 = 0) t1 FULL JOIN (SELECT t2 wr, b FROM fprt2 t2 WHERE t2.b % 25 = 0) t2 ON (t1.a = t2.b) ORDER BY 1,2;
+SELECT t1.wr, t2.wr FROM (SELECT t1 wr, a FROM fprt1 t1 WHERE t1.a % 25 = 0) t1 FULL JOIN (SELECT t2 wr, b FROM fprt2 t2 WHERE t2.b % 25 = 0) t2 ON (t1.a = t2.b) ORDER BY 1,2;
+SET postgres_fdw.use_cursor = true;
+
 -- join with lateral reference
 EXPLAIN (COSTS OFF)
 SELECT t1.a,t1.b FROM fprt1 t1, LATERAL (SELECT t2.a, t2.b FROM fprt2 t2 WHERE t1.a = t2.b AND t1.b = t2.a) q WHERE t1.a%25 = 0 ORDER BY 1,2;
 SELECT t1.a,t1.b FROM fprt1 t1, LATERAL (SELECT t2.a, t2.b FROM fprt2 t2 WHERE t1.a = t2.b AND t1.b = t2.a) q WHERE t1.a%25 = 0 ORDER BY 1,2;
 
+-- Test with non-cursor mode
+SET postgres_fdw.use_cursor = false;
+EXPLAIN (COSTS OFF)
+SELECT t1.a,t1.b FROM fprt1 t1, LATERAL (SELECT t2.a, t2.b FROM fprt2 t2 WHERE t1.a = t2.b AND t1.b = t2.a) q WHERE t1.a%25 = 0 ORDER BY 1,2;
+SELECT t1.a,t1.b FROM fprt1 t1, LATERAL (SELECT t2.a, t2.b FROM fprt2 t2 WHERE t1.a = t2.b AND t1.b = t2.a) q WHERE t1.a%25 = 0 ORDER BY 1,2;
+SET postgres_fdw.use_cursor = true;
+
 -- with PHVs, partitionwise join selected but no join pushdown
 EXPLAIN (COSTS OFF)
 SELECT t1.a, t1.phv, t2.b, t2.phv FROM (SELECT 't1_phv' phv, * FROM fprt1 WHERE a % 25 = 0) t1 FULL JOIN (SELECT 't2_phv' phv, * FROM fprt2 WHERE b % 25 = 0) t2 ON (t1.a = t2.b) ORDER BY t1.a, t2.b;
 SELECT t1.a, t1.phv, t2.b, t2.phv FROM (SELECT 't1_phv' phv, * FROM fprt1 WHERE a % 25 = 0) t1 FULL JOIN (SELECT 't2_phv' phv, * FROM fprt2 WHERE b % 25 = 0) t2 ON (t1.a = t2.b) ORDER BY t1.a, t2.b;
 
+-- Test with non-cursor mode
+SET postgres_fdw.use_cursor = false;
+EXPLAIN (COSTS OFF)
+SELECT t1.a, t1.phv, t2.b, t2.phv FROM (SELECT 't1_phv' phv, * FROM fprt1 WHERE a % 25 = 0) t1 FULL JOIN (SELECT 't2_phv' phv, * FROM fprt2 WHERE b % 25 = 0) t2 ON (t1.a = t2.b) ORDER BY t1.a, t2.b;
+SELECT t1.a, t1.phv, t2.b, t2.phv FROM (SELECT 't1_phv' phv, * FROM fprt1 WHERE a % 25 = 0) t1 FULL JOIN (SELECT 't2_phv' phv, * FROM fprt2 WHERE b % 25 = 0) t2 ON (t1.a = t2.b) ORDER BY t1.a, t2.b;
+SET postgres_fdw.use_cursor = true;
+
 -- test FOR UPDATE; partitionwise join does not apply
 EXPLAIN (COSTS OFF)
 SELECT t1.a, t2.b FROM fprt1 t1 INNER JOIN fprt2 t2 ON (t1.a = t2.b) WHERE t1.a % 25 = 0 ORDER BY 1,2 FOR UPDATE OF t1;
 SELECT t1.a, t2.b FROM fprt1 t1 INNER JOIN fprt2 t2 ON (t1.a = t2.b) WHERE t1.a % 25 = 0 ORDER BY 1,2 FOR UPDATE OF t1;
 
+-- Test with non-cursor mode
+SET postgres_fdw.use_cursor = false;
+EXPLAIN (COSTS OFF)
+SELECT t1.a, t2.b FROM fprt1 t1 INNER JOIN fprt2 t2 ON (t1.a = t2.b) WHERE t1.a % 25 = 0 ORDER BY 1,2 FOR UPDATE OF t1;
+SELECT t1.a, t2.b FROM fprt1 t1 INNER JOIN fprt2 t2 ON (t1.a = t2.b) WHERE t1.a % 25 = 0 ORDER BY 1,2 FOR UPDATE OF t1;
+SET postgres_fdw.use_cursor = true;
+
 RESET enable_partitionwise_join;
 
 
@@ -3333,22 +4454,46 @@ SET enable_partitionwise_aggregate TO false;
 EXPLAIN (COSTS OFF)
 SELECT a, sum(b), min(b), count(*) FROM pagg_tab GROUP BY a HAVING avg(b) < 22 ORDER BY 1;
 
+-- Test with non-cursor mode
+SET postgres_fdw.use_cursor = false;
+EXPLAIN (COSTS OFF)
+SELECT a, sum(b), min(b), count(*) FROM pagg_tab GROUP BY a HAVING avg(b) < 22 ORDER BY 1;
+SET postgres_fdw.use_cursor = true;
+
 -- Plan with partitionwise aggregates is enabled
 SET enable_partitionwise_aggregate TO true;
 EXPLAIN (COSTS OFF)
 SELECT a, sum(b), min(b), count(*) FROM pagg_tab GROUP BY a HAVING avg(b) < 22 ORDER BY 1;
 SELECT a, sum(b), min(b), count(*) FROM pagg_tab GROUP BY a HAVING avg(b) < 22 ORDER BY 1;
 
+-- Test with non-cursor mode
+SET postgres_fdw.use_cursor = false;
+SET enable_partitionwise_aggregate TO true;
+EXPLAIN (COSTS OFF)
+SELECT a, sum(b), min(b), count(*) FROM pagg_tab GROUP BY a HAVING avg(b) < 22 ORDER BY 1;
+SELECT a, sum(b), min(b), count(*) FROM pagg_tab GROUP BY a HAVING avg(b) < 22 ORDER BY 1;
+SET postgres_fdw.use_cursor = true;
+
 -- Check with whole-row reference
 -- Should have all the columns in the target list for the given relation
 EXPLAIN (VERBOSE, COSTS OFF)
 SELECT a, count(t1) FROM pagg_tab t1 GROUP BY a HAVING avg(b) < 22 ORDER BY 1;
 SELECT a, count(t1) FROM pagg_tab t1 GROUP BY a HAVING avg(b) < 22 ORDER BY 1;
 
+-- Test with non-cursor mode
+SET postgres_fdw.use_cursor = false;
+SELECT a, count(t1) FROM pagg_tab t1 GROUP BY a HAVING avg(b) < 22 ORDER BY 1;
+SET postgres_fdw.use_cursor = true;
+
 -- When GROUP BY clause does not match with PARTITION KEY.
 EXPLAIN (COSTS OFF)
 SELECT b, avg(a), max(a), count(*) FROM pagg_tab GROUP BY b HAVING sum(a) < 700 ORDER BY 1;
 
+-- Test with non-cursor mode
+SET postgres_fdw.use_cursor = false;
+EXPLAIN (COSTS OFF)
+SELECT b, avg(a), max(a), count(*) FROM pagg_tab GROUP BY b HAVING sum(a) < 700 ORDER BY 1;
+SET postgres_fdw.use_cursor = true;
 -- ===================================================================
 -- access rights and superuser
 -- ===================================================================
@@ -3905,6 +5050,11 @@ INSERT INTO result_tbl SELECT * FROM async_pt WHERE b % 100 = 0;
 INSERT INTO result_tbl SELECT * FROM async_pt WHERE b % 100 = 0;
 
 SELECT * FROM result_tbl ORDER BY a;
+
+-- Test with non-cursor mode
+SET postgres_fdw.use_cursor = false;
+SELECT * FROM result_tbl ORDER BY a;
+SET postgres_fdw.use_cursor = true;
 DELETE FROM result_tbl;
 
 EXPLAIN (VERBOSE, COSTS OFF)
@@ -3912,6 +5062,12 @@ INSERT INTO result_tbl SELECT * FROM async_pt WHERE b === 505;
 INSERT INTO result_tbl SELECT * FROM async_pt WHERE b === 505;
 
 SELECT * FROM result_tbl ORDER BY a;
+
+-- Test with non-cursor mode
+SET postgres_fdw.use_cursor = false;
+SELECT * FROM result_tbl ORDER BY a;
+SET postgres_fdw.use_cursor = true;
+
 DELETE FROM result_tbl;
 
 EXPLAIN (VERBOSE, COSTS OFF)
@@ -3919,12 +5075,24 @@ INSERT INTO result_tbl SELECT a, b, 'AAA' || c FROM async_pt WHERE b === 505;
 INSERT INTO result_tbl SELECT a, b, 'AAA' || c FROM async_pt WHERE b === 505;
 
 SELECT * FROM result_tbl ORDER BY a;
+
+-- Test with non-cursor mode
+SET postgres_fdw.use_cursor = false;
+SELECT * FROM result_tbl ORDER BY a;
+SET postgres_fdw.use_cursor = true;
+
 DELETE FROM result_tbl;
 
 -- Test error handling, if accessing one of the foreign partitions errors out
 CREATE FOREIGN TABLE async_p_broken PARTITION OF async_pt FOR VALUES FROM (10000) TO (10001)
   SERVER loopback OPTIONS (table_name 'non_existent_table');
 SELECT * FROM async_pt;
+
+-- Test with non-cursor mode
+SET postgres_fdw.use_cursor = false;
+SELECT * FROM async_pt;
+SET postgres_fdw.use_cursor = true;
+
 DROP FOREIGN TABLE async_p_broken;
 
 -- Check case where multiple partitions use the same connection
@@ -3939,6 +5107,11 @@ INSERT INTO result_tbl SELECT * FROM async_pt WHERE b === 505;
 INSERT INTO result_tbl SELECT * FROM async_pt WHERE b === 505;
 
 SELECT * FROM result_tbl ORDER BY a;
+
+-- Test with non-cursor mode
+SET postgres_fdw.use_cursor = false;
+SELECT * FROM result_tbl ORDER BY a;
+SET postgres_fdw.use_cursor = true;
 DELETE FROM result_tbl;
 
 -- Test COPY TO when foreign table is partition
@@ -3957,6 +5130,12 @@ INSERT INTO result_tbl SELECT * FROM async_pt WHERE b === 505;
 INSERT INTO result_tbl SELECT * FROM async_pt WHERE b === 505;
 
 SELECT * FROM result_tbl ORDER BY a;
+
+-- Test with non-cursor mode
+SET postgres_fdw.use_cursor = false;
+SELECT * FROM result_tbl ORDER BY a;
+SET postgres_fdw.use_cursor = true;
+
 DELETE FROM result_tbl;
 
 -- partitionwise joins
@@ -3969,6 +5148,12 @@ INSERT INTO join_tbl SELECT * FROM async_pt t1, async_pt t2 WHERE t1.a = t2.a AN
 INSERT INTO join_tbl SELECT * FROM async_pt t1, async_pt t2 WHERE t1.a = t2.a AND t1.b = t2.b AND t1.b % 100 = 0;
 
 SELECT * FROM join_tbl ORDER BY a1;
+
+-- Test with non-cursor mode
+SET postgres_fdw.use_cursor = false;
+SELECT * FROM join_tbl ORDER BY a1;
+SET postgres_fdw.use_cursor = true;
+
 DELETE FROM join_tbl;
 
 EXPLAIN (VERBOSE, COSTS OFF)
@@ -3976,6 +5161,12 @@ INSERT INTO join_tbl SELECT t1.a, t1.b, 'AAA' || t1.c, t2.a, t2.b, 'AAA' || t2.c
 INSERT INTO join_tbl SELECT t1.a, t1.b, 'AAA' || t1.c, t2.a, t2.b, 'AAA' || t2.c FROM async_pt t1, async_pt t2 WHERE t1.a = t2.a AND t1.b = t2.b AND t1.b % 100 = 0;
 
 SELECT * FROM join_tbl ORDER BY a1;
+
+-- Test with non-cursor mode
+SET postgres_fdw.use_cursor = false;
+SELECT * FROM join_tbl ORDER BY a1;
+SET postgres_fdw.use_cursor = true;
+
 DELETE FROM join_tbl;
 
 RESET enable_partitionwise_join;
@@ -3988,6 +5179,12 @@ INSERT INTO join_tbl SELECT * FROM async_p1 t1, async_pt t2 WHERE t1.a = t2.a AN
 INSERT INTO join_tbl SELECT * FROM async_p1 t1, async_pt t2 WHERE t1.a = t2.a AND t1.b = t2.b AND t1.b % 100 = 0;
 
 SELECT * FROM join_tbl ORDER BY a1;
+
+-- Test with non-cursor mode
+SET postgres_fdw.use_cursor = false;
+SELECT * FROM join_tbl ORDER BY a1;
+SET postgres_fdw.use_cursor = true;
+
 DELETE FROM join_tbl;
 
 RESET enable_hashjoin;
@@ -4010,6 +5207,12 @@ EXECUTE async_pt_query (3000, 505);
 EXECUTE async_pt_query (3000, 505);
 
 SELECT * FROM result_tbl ORDER BY a;
+
+-- Test with non-cursor mode
+SET postgres_fdw.use_cursor = false;
+SELECT * FROM result_tbl ORDER BY a;
+SET postgres_fdw.use_cursor = true;
+
 DELETE FROM result_tbl;
 
 EXPLAIN (VERBOSE, COSTS OFF)
@@ -4017,6 +5220,12 @@ EXECUTE async_pt_query (2000, 505);
 EXECUTE async_pt_query (2000, 505);
 
 SELECT * FROM result_tbl ORDER BY a;
+
+-- Test with non-cursor mode
+SET postgres_fdw.use_cursor = false;
+SELECT * FROM result_tbl ORDER BY a;
+SET postgres_fdw.use_cursor = true;
+
 DELETE FROM result_tbl;
 
 RESET plan_cache_mode;
@@ -4041,6 +5250,11 @@ EXPLAIN (ANALYZE, COSTS OFF, SUMMARY OFF, TIMING OFF, BUFFERS OFF)
 SELECT * FROM local_tbl, async_pt WHERE local_tbl.a = async_pt.a AND local_tbl.c = 'bar';
 SELECT * FROM local_tbl, async_pt WHERE local_tbl.a = async_pt.a AND local_tbl.c = 'bar';
 
+-- Test with non-cursor mode
+SET postgres_fdw.use_cursor = false;
+SELECT * FROM local_tbl, async_pt WHERE local_tbl.a = async_pt.a AND local_tbl.c = 'bar';
+SET postgres_fdw.use_cursor = true;
+
 ALTER FOREIGN TABLE async_p1 OPTIONS (DROP use_remote_estimate);
 ALTER FOREIGN TABLE async_p2 OPTIONS (DROP use_remote_estimate);
 
@@ -4066,6 +5280,12 @@ UNION
 (SELECT a, b, 'AAA' || c FROM async_p2 WHERE b < 10);
 
 SELECT * FROM result_tbl ORDER BY a;
+
+-- Test with non-cursor mode
+SET postgres_fdw.use_cursor = false;
+SELECT * FROM result_tbl ORDER BY a;
+SET postgres_fdw.use_cursor = true;
+
 DELETE FROM result_tbl;
 
 EXPLAIN (VERBOSE, COSTS OFF)
@@ -4079,6 +5299,12 @@ UNION ALL
 (SELECT a, b, 'AAA' || c FROM async_p2 WHERE b < 10);
 
 SELECT * FROM result_tbl ORDER BY a;
+
+-- Test with non-cursor mode
+SET postgres_fdw.use_cursor = false;
+SELECT * FROM result_tbl ORDER BY a;
+SET postgres_fdw.use_cursor = true;
+
 DELETE FROM result_tbl;
 
 RESET enable_incremental_sort;
@@ -4106,6 +5332,11 @@ EXPLAIN (VERBOSE, COSTS OFF)
 SELECT * FROM async_pt t1, async_p2 t2 WHERE t1.a = t2.a AND t1.b === 505;
 SELECT * FROM async_pt t1, async_p2 t2 WHERE t1.a = t2.a AND t1.b === 505;
 
+-- Test with non-cursor mode
+SET postgres_fdw.use_cursor = false;
+SELECT * FROM async_pt t1, async_p2 t2 WHERE t1.a = t2.a AND t1.b === 505;
+SET postgres_fdw.use_cursor = true;
+
 CREATE TABLE local_tbl (a int, b int, c text);
 INSERT INTO local_tbl VALUES (1505, 505, 'foo');
 ANALYZE local_tbl;
@@ -4116,12 +5347,22 @@ EXPLAIN (ANALYZE, COSTS OFF, SUMMARY OFF, TIMING OFF, BUFFERS OFF)
 SELECT * FROM local_tbl t1 LEFT JOIN (SELECT *, (SELECT count(*) FROM async_pt WHERE a < 3000) FROM async_pt WHERE a < 3000) t2 ON t1.a = t2.a;
 SELECT * FROM local_tbl t1 LEFT JOIN (SELECT *, (SELECT count(*) FROM async_pt WHERE a < 3000) FROM async_pt WHERE a < 3000) t2 ON t1.a = t2.a;
 
+-- Test with non-cursor mode
+SET postgres_fdw.use_cursor = false;
+SELECT * FROM local_tbl t1 LEFT JOIN (SELECT *, (SELECT count(*) FROM async_pt WHERE a < 3000) FROM async_pt WHERE a < 3000) t2 ON t1.a = t2.a;
+SET postgres_fdw.use_cursor = true;
+
 EXPLAIN (VERBOSE, COSTS OFF)
 SELECT * FROM async_pt t1 WHERE t1.b === 505 LIMIT 1;
 EXPLAIN (ANALYZE, COSTS OFF, SUMMARY OFF, TIMING OFF, BUFFERS OFF)
 SELECT * FROM async_pt t1 WHERE t1.b === 505 LIMIT 1;
 SELECT * FROM async_pt t1 WHERE t1.b === 505 LIMIT 1;
 
+-- Test with non-cursor mode
+SET postgres_fdw.use_cursor = false;
+SELECT * FROM async_pt t1 WHERE t1.b === 505 LIMIT 1;
+SET postgres_fdw.use_cursor = true;
+
 -- Check with foreign modify
 CREATE TABLE base_tbl3 (a int, b int, c text);
 CREATE FOREIGN TABLE remote_tbl (a int, b int, c text)
@@ -4138,6 +5379,11 @@ INSERT INTO insert_tbl (SELECT * FROM local_tbl UNION ALL SELECT * FROM remote_t
 
 SELECT * FROM insert_tbl ORDER BY a;
 
+-- Test with non-cursor mode
+SET postgres_fdw.use_cursor = false;
+SELECT * FROM insert_tbl ORDER BY a;
+SET postgres_fdw.use_cursor = true;
+
 -- Check with direct modify
 EXPLAIN (VERBOSE, COSTS OFF)
 WITH t AS (UPDATE remote_tbl SET c = c || c RETURNING *)
@@ -4146,6 +5392,12 @@ WITH t AS (UPDATE remote_tbl SET c = c || c RETURNING *)
 INSERT INTO join_tbl SELECT * FROM async_pt LEFT JOIN t ON (async_pt.a = t.a AND async_pt.b = t.b) WHERE async_pt.b === 505;
 
 SELECT * FROM join_tbl ORDER BY a1;
+
+-- Test with non-cursor mode
+SET postgres_fdw.use_cursor = false;
+SELECT * FROM join_tbl ORDER BY a1;
+SET postgres_fdw.use_cursor = true;
+
 DELETE FROM join_tbl;
 
 DROP TABLE local_tbl;
-- 
2.39.5 (Apple Git-154)

